// FLINKLIB.H 
// Ver 0.10
//	Copyright (C) 2004 CASIO COMPUTER CO.,LTD.
//	CASIO CONFIDENTIAL
//

#ifndef __FLINKLIB_LIB__
#define __FLINKLIB_LIB__

#include <windows.h>

/*------------- Symbol Definition -----------------------------------*/

#define	FLK_A_NORMAL		0x00		/* ǂݏ\              */
#define	FLK_A_RDONLY		0x01		/* ǂݍݐp              */
#define	FLK_A_HIDDEN		0x02		/* Bt@C              */
#define	FLK_A_SYSTEM		0x04		/* VXet@C          */
#define	FLK_A_VOLID			0x08		/* {[ID              */
#define	FLK_A_SUBDIR		0x10		/* TufBNg          */
#define	FLK_A_ARCH			0x20		/* A[JCu                */

/*============= Return Code =========================================*/
#define	FLK_OK				0			/* NORMAL END				*/
#define	FLK_PRM				0xFFFFFFFE	/* parameter error           */
#define	FLK_NG				0xFFFFFFFF	/* error end                 */

/*============= Message =============================================*/
#define	FLK_COMMAND_END		0			/* NORMAL END				*/
#define	FLK_COMMAND_ERROR	1			/* ERROR END				*/
#define	FLK_STATUS_CHANGE1	2			/* STATUS CHANGE 1 			*/
#define	FLK_STATUS_CHANGE2	3			/* STATUS CHANGE 2			*/

/*============= FLKOpen =============================================*/

#define	FLK_B1200			0x01		/* line speed 1200BPS        */
#define	FLK_B2400			0x02		/*            2400BPS        */
#define	FLK_B4800			0x03		/*            4800BPS        */
#define	FLK_B9600			0x04		/*            9600BPS        */
#define	FLK_B19K			0x05		/*           19200BPS        */
#define	FLK_B38K			0x06		/*           38400BPS        */
#define	FLK_B57K			0x07		/*           57600BPS        */
#define	FLK_B115K			0x08		/*          115200BPS        */

#define	FLK_CHAR7			0x01		/* data length 7bits         */
#define	FLK_CHAR8			0x02		/*             8bits         */

#define	FLK_PARI_ODD		0x01		/* parity   odd              */
#define	FLK_PARI_EVN		0x02		/*          even             */
#define	FLK_PARI_NON		0x03		/*          none             */

#define	FLK_STOP1			0x01		/* stop bit 1bit             */
#define	FLK_STOP2			0x02		/*          2bits            */

#define	FLK_MODE_HT			0x01		/* send privilege mode HT side */
#define	FLK_MODE_PC			0x02		/*                     PC side */

/*============= FLK_fileSend =========================================*/
/*============= FLK_fileAdd  =========================================*/
/*============= FLK_fileRecv =========================================*/
#define	FLK_TRANS_NORMAL	0x01		/* send mode normal send     */
#define	FLK_TRANS_RECURSIVE	0x02		/*           recursive       */

#define	FLK_PROTECT_VALID	0x01		/* overwrite mode valid      */
#define	FLK_PROTECT_INVALID	0x02		/*                invalid    */

#define	FLK_GRAPH_NM_PATH	0x01		/* display file name all path */
#define	FLK_GRAPH_NM_FILE	0x02		/* file name display         */

/*============= FLK_close ============================================*/
#define FLK_CLOSE_NORMAL	0x0000		/* end notice  normal        */
#define FLK_CLOSE_FORMAT_A	0xDC00		/*          A drive format   */
#define FLK_CLOSE_FORMAT_B	0xDD00		/*          B drive format   */
#define FLK_CLOSE_FORMAT_C	0xDE00		/*          C drive format   */
#define FLK_CLOSE_FORMAT_D	0xDF00		/*          D drive format   */
#define FLK_CLOSE_FORMAT_E	0xE000		/*          E drive format   */
#define FLK_CLOSE_FORMAT_F	0xE100		/*          F drive format   */
#define FLK_CLOSE_FORMAT_G	0xE200		/*          G drive format   */
#define FLK_CLOSE_FORMAT_H	0xE300		/*          H drive format   */
#define FLK_CLOSE_FORMAT_I	0xE400		/*          I drive format   */
#define FLK_CLOSE_FORMAT_J	0xE500		/*          J drive format   */
#define FLK_CLOSE_FORMAT_K	0xE600		/*          K drive format   */
#define FLK_CLOSE_FORMAT_L	0xE700		/*          L drive format   */
#define FLK_CLOSE_FORMAT_M	0xE800		/*          M drive format   */
#define FLK_CLOSE_FORMAT_N	0xE900		/*          N drive format   */
#define FLK_CLOSE_FORMAT_O	0xEA00		/*          O drive format   */
#define FLK_CLOSE_FORMAT_P	0xEB00		/*          P drive format   */
#define FLK_CLOSE_FORMAT_Q	0xEC00		/*          Q drive format   */
#define FLK_CLOSE_FORMAT_R	0xED00		/*          R drive format   */
#define FLK_CLOSE_FORMAT_S	0xEE00		/*          S drive format   */
#define FLK_CLOSE_FORMAT_T	0xEF00		/*          T drive format   */
#define FLK_CLOSE_FORMAT_U	0xF000		/*          U drive format   */
#define FLK_CLOSE_FORMAT_V	0xF100		/*          V drive format   */
#define FLK_CLOSE_FORMAT_W	0xF200		/*          W drive format   */
#define FLK_CLOSE_FORMAT_X	0xF300		/*          X drive format   */
#define FLK_CLOSE_FORMAT_Y	0xF400		/*          Y drive format   */
#define FLK_CLOSE_FORMAT_Z	0xF500		/*          Z drive format   */
#define FLK_CLOSE_PWROFF	0xF600		/*          power OFF        */
#define FLK_CLOSE_RESET		0xF700		/*         reset command send*/

/*============= FLKReadStatus ======================================*/
#define	FLK_SND_EXEC			1
#define	FLK_RCV_EXEC			2
#define	FLK_ADDSND_EXEC			3
#define	FLK_ADDRCV_EXEC			4
#define	FLK_DELETE_EXEC			5
#define	FLK_DELETE_RECV			6
#define	FLK_MOVE_EXEC			7
#define	FLK_MOVE_RECV			8
#define	FLK_MAKEDIR_RECV		9
#define	FLK_DATETIME_EXEC		10
#define	FLK_DATETIME_RECV		11
#define	FLK_DATETIME_SEND		12
#define	FLK_MESSAGE_RECV		13
#define	FLK_BUZZER_RECV			14
#define	FLK_GETFILEINFO_RECV	15
#define	FLK_SETFILEINFO_RECV	16
#define	FLK_GETDISKINFO_RECV	17

#define	FLK_STATUS_RUNNING		1
#define	FLK_STATUS_END			2
#define	FLK_STATUS_ERROR		3

/*============= FLKReadErrStat ======================================*/
#define	FLK_CMD_FSEND_TINFO	1			/* file send information command */
#define	FLK_CMD_FSEND_FINFO	2			/* file information command  */
#define	FLK_CMD_FRECV_TREQ	3			/* file receive request command  */
#define	FLK_CMD_FADD		4			/* file add command          */
#define	FLK_CMD_FDATA		5			/* file delete command       */
#define	FLK_CMD_FDEL		6			/* file delete command       */
#define	FLK_CMD_FMOV		7			/* file move command         */
#define	FLK_CMD_MAKEDIR		8			/* make directory command    */
#define	FLK_CMD_TIME_SET	9			/* date time set command     */
#define	FLK_CMD_TIME_GET	10			/* date time get command     */
#define	FLK_CMD_DISP		11			/* message display command   */
#define	FLK_CMD_BEEP		12			/* buzzer sound command      */
#define	FLK_CMD_FINFO_GET	13			/* file information get command  */
#define	FLK_CMD_FINFO_SET	14			/* file information set command  */
#define	FLK_CMD_DINFO_GET	15			/* disk information get command  */
#define	FLK_CMD_SYS_GET		16			/* system information get command*/
#define	FLK_CMD_IDLE		17			/* idle notice command       */
#define	FLK_CMD_END			18			/* end set command           */

/*============= FLK_cmdRecv ==========================================*/
#define	FLK_RECV_END		1			/* received end command      */
#define	FLK_RECV_IDLE		2			/* received idle notice      */
/*============= FLK_makeDir ==========================================*/
/*============= FLK_dateTime =========================================*/
#define	FLK_GET_MODE		1			/* get information           */
#define	FLK_SET_MODE		2			/* set information           */
/*============= FLK_getFileInfo ======================================*/
#define	FLK_GET_FIRST		1			/* get first information     */
#define	FLK_GET_NEXT		2			/* get next information      */
/*============= FLK_getDiskInfo ======================================*/
#define	FLK_DINFO_NORMAL	0x00		/* format                    */
#define	FLK_DINFO_NOFMT		0x01		/* non-format                */
#define	FLK_DINFO_NODISK	0x02		/* no disk                   */


/*------------- Struct Definition -----------------------------------*/

/*================ serial communication parameter format ============*/
typedef struct{
	WORD	speed;						/* send speed                */
	WORD	length;						/* data length               */
	WORD	parity;						/* parity bit                */
	WORD	stop_bit;					/* stop bit                  */
}FLK_RSPRM;

/*================  status parameter format ===============*/
typedef struct {
	WORD	status;						/* command end status		*/
	WORD	function;					/* command kind				*/
	TCHAR	FileName[256];				/* filename / message		*/
	DWORD	total_size;					/* total file size 			*/
	DWORD	total_count;				/* total send byte count	*/
	DWORD	file_size;					/* send file size			*/
	DWORD	file_count;					/* send byte count			*/
} FLK_STATUS;

/*================ error information parameter format ===============*/
typedef struct{
	BYTE	kind;						/* error kind                */
	BYTE	command;					/* command type              */
	BYTE	category;					/* category type             */
	BYTE	detail;						/* error detail              */
	DWORD	biosStat;					/* bios status detail        */
}FLK_ERRINFO;

/*================ date time information parameter format ===========*/
typedef struct{
	BYTE	day;						/* date   (1-31)             */
	BYTE	month;						/* month  (1-12)             */
	WORD	year;						/* year   (1980-2047)        */
	BYTE	sec;						/* second (0-59)             */
	BYTE	min;						/* minite (0-59)             */
	BYTE	hour;						/* hour   (0-23)             */
}FLK_DATETIME;

/*================ file information parameter format ================*/
typedef struct{
	TCHAR			name[256];			/* file name                 */
	FLK_DATETIME	datetime;			/* date time information area*/
	DWORD			size;				/* size                      */
	BYTE			atr;				/* attribute                 */
}FLK_FINFO;

/*================ disk information parameter format ================*/
typedef struct{
	DWORD	size;						/* disk size                 */
	DWORD	freex;						/* disk free size            */
	BYTE	status;						/* disk status               */
}FLK_DINFO;

/*================ system information parameter format ==============*/
typedef	struct{
	WORD	id;							/* session ID                */
	BYTE	ftpver;						/* protcol ver               */
	BYTE	code[3];					/* machine code              */
	BYTE	model;						/* model information         */
}FLK_SYSINFO;

/*================ file information parameter format ex =============*/
typedef struct{
	TCHAR			name[256];			/* file name                 */
	BYTE			day;				/* date   (1-31)             */
	BYTE			month;				/* month  (1-12)             */
	WORD			year;				/* year   (1980-2047)        */
	BYTE			sec;				/* second (0-59)             */
	BYTE			min;				/* minite (0-59)             */
	BYTE			hour;				/* hour   (0-23)             */
	DWORD			size;				/* size                      */
	BYTE			atr;				/* attribute                 */
}FLK_FINFOEX;



#ifdef __cplusplus
extern "C"
{
#endif

HANDLE	FLKOpen(TCHAR *device, char *cString, FLK_RSPRM *rsprm,WORD mode,HWND hwnd,UINT message);
DWORD	FLKFileSend(HANDLE hPort, WORD mode, TCHAR *fName, TCHAR *dir, WORD protect);
DWORD	FLKFileAdd(HANDLE hPort, TCHAR *sfName, TCHAR *rfName);
DWORD	FLKFileRecv(HANDLE hPort, WORD mode, TCHAR *fName, TCHAR *dir, WORD protect);
DWORD	FLKClose(HANDLE hPort,WORD endKind);
DWORD	FLKReadErrStat(HANDLE hPort,FLK_ERRINFO *errinfo);
DWORD	FLKReadStatus(HANDLE hPort,FLK_STATUS *flkstatus);
DWORD	FLKIdle(HANDLE hPort, TCHAR	*script);
DWORD	FLKCmdRecv(HANDLE hPort,WORD *endKind,TCHAR *script);
DWORD	FLKFileDelete(HANDLE hPort, TCHAR *fName);
DWORD	FLKFileMove(HANDLE hPort, TCHAR *sfName, TCHAR *dfName);
DWORD	FLKMakeDir(HANDLE hPort, TCHAR *mDir, FLK_DATETIME *datetime,BYTE atr);
DWORD	FLKGetFileInfo(HANDLE hPort,WORD mode,TCHAR *fName,FLK_FINFO *finfo);
DWORD	FLKSetFileInfo(HANDLE hPort,FLK_FINFO *finfo);
DWORD	FLKGetDiskInfo(HANDLE hPort,BYTE drive,FLK_DINFO *dinfo);
DWORD	FLKDateTime(HANDLE hPort, WORD mode,FLK_DATETIME *datetime);
DWORD	FLKGetSysInfo(HANDLE hPort, FLK_SYSINFO *sysinfo);
DWORD	FLKMsgSend(HANDLE hPort,TCHAR *msg);
DWORD	FLKBeep(HANDLE hPort);
DWORD	FLKGetFileInfoEx(HANDLE hPort,WORD mode,TCHAR *fName,FLK_FINFOEX *finfoex);
DWORD	FLKSetFileInfoEx(HANDLE hPort,FLK_FINFOEX *finfoex);

#ifdef __cplusplus
}
#endif
#endif
